atom/proc/GetDenseObject()
	for(var/obj/O in src) if(O.density) if(!O.qloc) return O
	for(var/mob/M in src) if(M.density) if(!M.qloc) return M

turf/GetDenseObject()
	if(density) return src
	if(loc.density) return loc
	else return ..()

qturf
	parent_type = /obj

	var/list/quasicontents

	GetDenseObject()
		if(density) return src
		for(var/obj/O in quasicontents) if(O.density) return O
		for(var/mob/M in quasicontents) if(M.density) return M
		var/area/area = loc
		while(area && !isarea(area)) area = area.loc
		if(area && area.density) return area

	New()
		quasicontents = list()

	Move(newlocloc, newdir)
		var/atom/oldloc = loc
		. = ..()
		if(.)
			for(var/atom/movable/A in quasicontents)
				if(A.loc == oldloc)
					A.loc = src.loc
				else
					quasicontents -= A

	Enter(atom/movable/A)
		if(istype(A, /qturf)) return 0
		if(A.density)
			for(var/atom/movable/M in quasicontents)
				if(M.loc == src.loc)
					if(M.density)
						return 0
				else
					quasicontents -= M
		return ..()

	Entered(atom/movable/A)
		quasicontents += A
		..()

	Exited(atom/movable/A)
		quasicontents -= A
		..()

atom
	Enter(atom/movable/A)
		if(isturf(src))
			if(A.density)
				if(density)
					return 0
				if(loc.density)
					return 0
				for(var/obj/O in src)
					if(O.density)
						if(!O.qloc)
							return 0
				for(var/mob/M in src)
					if(M.density)
						if(!M.qloc)
							return 0
			return 1
		return ..()


atom/movable

	var/qturf/qloc

	Move(atom/newloc, newdir)
		if(isturf(newloc))
			for(var/qturf/Q in newloc)
				if(Move(Q, newdir))
					return 1

			. = ..()
			if(.)
				if(qloc)
					qloc.Exited(src)
					qloc = null
				return .

		if(istype(newloc, /qturf))

			if(newdir) dir=newdir
			if(!newloc) return 0
			var/qturf/oldqloc = qloc

			if(loc && newloc && !newdir) dir = get_dir(loc, newloc)

			if(oldqloc) //Moving from a qturf to another qturf
				if(!oldqloc.Exit(src)) return 0

				var/area/area1 = oldqloc
				var/area/area2 = newloc
				while(area1 && !isarea(area1)) area1 = area1.loc
				while(area2 && !isarea(area2)) area2 = area2.loc

				if(area1 && area1 != area2 && !area1.Exit(src)) return 0

				if(!newloc.Enter(src))
					var/DO = newloc.GetDenseObject()
					if(DO) Bump(DO)
					return 0

				if(area2 && area1 != area2 && !area2.Enter(src))
					var/DO = newloc.GetDenseObject()
					if(DO) Bump(DO)
					return 0

				// if something else moved us already, abort
				if(qloc != oldqloc) return 0
				qloc = newloc //We've moved!
				loc = newloc.loc

				//Big chunk of code to call Entered() and Exited()
				oldqloc.Exited(src)
				if(area1 && area1 != area2)
					area1.Exited(src)
				qloc.Entered(src, oldqloc)
				if(area2 && area1 != area2 && !isarea(loc))
					area2.Entered(src, oldqloc)

				return 1

			else //Moving from anything else to a qturf
				var/atom/oldloc = loc

				if(oldloc && !oldloc.Exit(src)) return 0

				var/area/area1 = oldloc
				var/area/area2 = newloc
				while(area1 && !isarea(area1)) area1 = area1.loc
				while(area2 && !isarea(area2)) area2 = area2.loc

				if(area1 && area1 != area2 && isturf(oldloc) && !area1.Exit(src)) return 0

				if(!newloc.Enter(src))
					var/DO = newloc.GetDenseObject()
					if(DO) Bump(DO)
					return 0

				if(area2 && area1 != area2 && !area2.Enter(src))
					var/DO = newloc.GetDenseObject()
					if(DO) Bump(DO)
					return 0

				// if something else moved us already, abort
				if(qloc != oldqloc) return 0
				qloc = newloc //We've moved!
				loc = newloc.loc

				//Big chunk of code to call Entered() and Exited()
				if(oldloc) oldloc.Exited(src)
				if(area1 && area1 != area2)
					area1.Exited(src)
				qloc.Entered(src, oldloc)
				if(area2 && area1 != area2 && !isarea(loc))
					area2.Entered(src, oldloc)

				return 1

		else
			. = ..()
			if(.)
				qloc = null
			return .




mob/Bump(atom/A)
	if(ismob(A))
		var/mob/M = A
		if(src in M.group)
			var/swap = qloc
			qloc = M.qloc
			M.qloc = swap
	..()